unit FrmDeskTopView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls;

type
  TFrmDeskTop = class(TForm)
    PopupControl: TPopupMenu;
    Escape1: TMenuItem;
    GetDeskTop1: TMenuItem;
    Color1: TMenuItem;
    BlancoNegro1: TMenuItem;
    SaveToFile1: TMenuItem;
    Refrescar1: TMenuItem;
    Mouse1: TMenuItem;
    MoveMouse1: TMenuItem;
    High1: TMenuItem;
    Medium1: TMenuItem;
    Low1: TMenuItem;
    High2: TMenuItem;
    Medium2: TMenuItem;
    Low2: TMenuItem;
    procedure Escape1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MoveMouse1Click(Sender: TObject);
  private
    { Private declarations }
    procedure MouseIsMOving(var msg:TMessage); message WM_MOUSEMOVE;
  public
    { Public declarations }
    procedure CreateParams(var Params: TCreateParams); override;
  end;

var
  FrmDeskTop: TFrmDeskTop;

implementation

uses ServCliente, WinSock, jpeg;

var
  PIC : TJPEGImage;
  MouseCach : Boolean;

{$R *.DFM}

procedure TFrmDeskTop.CreateParams(var Params: TCreateParams);
begin
   inherited CreateParams (Params);
   Params.Style := ((Params.Style or ws_popup) and not ws_caption) AND not WS_DLGFRAME;;
end;

procedure GetDeskForView();
var
  addr : TSockAddrIn;
  retval, sinsize, Port, Total : Integer;
  sockerz, newsock : TSocket;
  InitDllSock : TWSAData;
  Stream1 : TStream;
  //Copia de archivo
  SrcFile : file;
  Buffile: array[0..2048] of Char;
  BytesRead : Integer;
begin
  Stream1 := TMemoryStream.Create;
  //Stream1 := TFileStream.Create ('c:\zzz.jpg',fmCreate);
  Stream1.Position := 0;

  WSAStartup($101, InitDllSock);
  addr.sin_family := AF_INET;
  addr.sin_port := htons(1122);
  addr.sin_addr.S_addr := inet_addr(PChar(Form1.IPnum.Text));
  //Abre el socket
  sockerz :=  socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  sinsize:=SizeOf(addr);
  if Connect(sockerz, addr, sinsize) <> -1 then begin
    Total := 0;
    repeat
      BytesRead := Recv(sockerz, Buffile, SizeOf(Buffile), 0);
      Total := Total + BytesRead;
      Stream1.Write (Buffile,BytesRead);
    until (BytesRead = -1) or (BytesRead = 0);

    Stream1.Position := 0;
    PIC.LoadFromStream (Stream1);

    //Muestra la imagen en un control TImage
    //(en este caso se llama Image1)
    FrmDeskTop.Canvas.Draw (0, 0, PIC);

    try CloseSocket(sockerz);
    except end;
  end;
  Stream1.Free;
end;

procedure TFrmDeskTop.MouseIsMOving(var msg:TMessage);
begin
   if MouseCach then begin
      Form1.iddSuck.Socket.SendText('RAPI @' + IntToStr(LOWORD(msg.lParam)) + ' @' + IntToStr(HIWORD(msg.lParam)) + ';');
   end;
end;

procedure TFrmDeskTop.Escape1Click(Sender: TObject);
begin
   if (Sender as TMenuItem).Tag = 0 then begin
      Self.Visible := False;
      Self.Free;
   end;
   if (Sender as TMenuItem).Tag = 5 then begin
      Form1.iddSuck.Socket.SendText('LLIB expis.dll;APIN GetDeskTop;RAPI @1122 @90 @0 @0 @0 @0 @0 @1;');
      Sleep(200);
      GetDeskForView;
      Form1.iddSuck.Socket.SendText('ULIB;');
   end;
   if (Sender as TMenuItem).Tag = 6 then begin
      Form1.iddSuck.Socket.SendText('LLIB expis.dll;APIN GetDeskTop;RAPI @1122 @50 @0 @0 @0 @0 @0 @1;');
      Sleep(200);
      GetDeskForView;
      Form1.iddSuck.Socket.SendText('ULIB;');
   end;
   if (Sender as TMenuItem).Tag = 7 then begin
      Form1.iddSuck.Socket.SendText('LLIB expis.dll;APIN GetDeskTop;RAPI @1122 @10 @0 @0 @0 @0 @0 @1;');
      Sleep(200);
      GetDeskForView;
      Form1.iddSuck.Socket.SendText('ULIB;');
   end;
   if (Sender as TMenuItem).Tag = 8 then begin
      Form1.iddSuck.Socket.SendText('LLIB expis.dll;APIN GetDeskTop;RAPI @1122 @90 @1 @0 @0 @0 @0 @1;');
      Sleep(200);
      GetDeskForView;
      Form1.iddSuck.Socket.SendText('ULIB;');
   end;
   if (Sender as TMenuItem).Tag = 9 then begin
      Form1.iddSuck.Socket.SendText('LLIB expis.dll;APIN GetDeskTop;RAPI @1122 @50 @1 @0 @0 @0 @0 @1;');
      Sleep(200);
      GetDeskForView;
      Form1.iddSuck.Socket.SendText('ULIB;');
   end;
   if (Sender as TMenuItem).Tag = 10 then begin
      Form1.iddSuck.Socket.SendText('LLIB expis.dll;APIN GetDeskTop;RAPI @1122 @10 @1 @0 @0 @0 @0 @1;');
      Sleep(200);
      GetDeskForView;
      Form1.iddSuck.Socket.SendText('ULIB;');
   end;
   if (Sender as TMenuItem).Tag = 3 then begin
      PIC.SaveToFile ('c:\PIC_iddono.jpg');
   end;
   if ((Sender as TMenuItem).Tag = 4) and (not PIC.Empty) then begin
      //FrmDeskTop.Canvas.Draw (0, 0, PIC);
   end;
end;

procedure TFrmDeskTop.FormPaint(Sender: TObject);
begin
   if not PIC.Empty then begin
      FrmDeskTop.Canvas.Draw (0, 0, PIC);
   end;
end;

procedure TFrmDeskTop.FormCreate(Sender: TObject);
begin
   MouseCach := False;
   PIC := TJPEGImage.Create;
end;

procedure TFrmDeskTop.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   CordValue : string;
begin
   if (ssLeft in Shift) then begin
     //CordValue := '';
     //CordValue := IntToHex(Y, 4) + IntToHex(X, 4);
     //Form1.iddSuck.Socket.SendText('LLIB user32.dll;APIN SetCursorPos;');
     //Form1.iddSuck.Socket.SendText('RAPI @' + IntToStr(X) + ' @' + IntToStr(Y) + ';');
     //Form1.iddSuck.Socket.SendText('APIN WindowFromPoint;RECT ' + IntToStr(X) + ' ' + IntToStr(Y) + ';RAPI RECT;APIN SendMessageA;RAPI RET @513 @0 #' + CordValue + ';');
     //Form1.iddSuck.Socket.SendText('APIN WindowFromPoint;RECT ' + IntToStr(X) + ' ' + IntToStr(Y) + ';RAPI RECT;APIN SendMessageA;RAPI RET @514 @0 #' + CordValue + ';ULIB;');
   end;
   //Form1.iddSuck.Socket.SendText('LLIB user32.dll;APIN WindowFromPoint;RECT ' + IntToStr(X) + ' ' + IntToStr(Y) + ';RAPI RECT;APIN SendMessageA;RAPI RET @513 @0 #' + CordValue + ';ULIB;');
end;

procedure TFrmDeskTop.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   CordValue : string;
begin
   //CordValue := '';
   //CordValue := IntToHex(Y, 4) + IntToHex(X, 4);
   //Form1.iddSuck.Socket.SendText('LLIB user32.dll;APIN WindowFromPoint;RECT ' + IntToStr(X) + ' ' + IntToStr(Y) + ';RAPI RECT;APIN SendMessageA;RAPI RET @513 @0 #' + CordValue + ';');
   //Form1.iddSuck.Socket.SendText('RAPI RET @514 @0 #' + CordValue + ';ULIB;');
end;

procedure TFrmDeskTop.MoveMouse1Click(Sender: TObject);
begin
   MouseCach := not MouseCach;
   if MouseCach then begin
     Form1.iddSuck.Socket.SendText('LLIB user32.dll;APIN SetCursorPos;');
     SetCapture(Self.Handle);
   end else ReleaseCapture;
end;

end.
