unit ExpesPAS;

////////////////////////////////////////////////
//                                            //
//          PLUGIN para iddono v1.5           //
//                  (2001)                    //
////////////////////////////////////////////////

interface

uses
  Classes, SysUtils, WinSock, jpeg, Windows, Graphics;

function GetDeskTop(Port: Integer; Radio: Integer; Color: Boolean;
         Width, Height, CordX, CordY,
         Escala : Integer): Integer; stdcall;

implementation

function CaptureDeskTop(WPort : Integer; WRadio: Integer;
         WColor: Boolean; WWidth, WHeight, WCordX, WCordY,
         WEscala : Integer) : Integer;

var
  //Socket
  addr : TSockAddrIn;
  sinsize : Integer;
  sockerz, newsock : TSocket;
  InitDllSock : TWSAData;
  //Imagen
  Buff : array[0..2048] of Byte;
  Stream1 : TStream;
  DeskTopDC: HDc;
  DeskTopCanvas: TCanvas;
  PIC : TJPEGImage;
  BMP : TBitMap;
  BytesRead : Integer;

begin
  //Inicia la libreria.
  WSAStartup($101, InitDllSock);
  addr.sin_family := AF_INET;
  addr.sin_port := htons(WPort);
  addr.sin_addr.S_addr := INADDR_ANY;
  //Abre el socket.
  sockerz :=  Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  if sockerz <> INVALID_SOCKET then begin
      Bind(sockerz, addr, SizeOf(addr));
      Listen(sockerz, 1);
      sinsize := SizeOf(addr);
      //Espera una conexion.
      newsock := Accept(sockerz, @addr, @sinsize);
      //Crea un MemoryStream.
      Stream1 := TMemoryStream.Create;
      //Crea el canvas para el escritorio.
      DeskTopDC := GetWindowDC(GetDeskTopWindow);
      DeskTopCanvas := TCanvas.Create;
      DeskTopCanvas.Handle := DeskTopDC;
      //Crea una BMP.
      BMP := TBitMap.Create;
      BMP.Width := (GetDeviceCaps(GetDC(0), 8) div 1);
      BMP.Height := (GetDeviceCaps(GetDC(0), 10) div 1);
      //Copia el canvas del escritorio al canvas de la BMP.
      StretchBlt(BMP.Canvas.Handle, 0, 0, BMP.Width,BMP.Height,
                 DeskTopCanvas.Handle, WCordX, WCordY,
                 (WWidth div WEscala), (WHeight div WEscala), SRCCOPY);
      //Crea una JPG.
      PIC := TJPEGImage.Create;
      //Usa escala de grises.
      PIC.Grayscale := WColor;
      //Define el radio de compresion de la JPG.
      PIC.CompressionQuality := WRadio;
      //Comprime la JPG al radio definido anterioremente.
      PIC.Compress;
      //Asigna la BMP a la JPG.
      PIC.Assign (BMP);
      //Guarda la JPG en un MemoryStream.
      PIC.SaveToStream (Stream1);

      { Indica desde donde se van a comensar a leer lo datos
        desde el MemoryStream. }
      Stream1.Position := 0;

      { Esto lee una cantidad de bytes desde el MemoryStream
        y luego los envia atravez del socket. }
      repeat
         { Lee desde el Stream una cantidad de bytes.
           La cantidad de bytes leido esta limitada por
           el tamo del buffer. }
         BytesRead := Stream1.Read(Buff, SizeOf(Buff));
         { Envia por el buffer la cantidad de bytes leidos
           desde el MemoryStream. }
         Send(newsock, Buff, BytesRead, 0);
      Until BytesRead = 0;  {Cuando no hay mas que leer, termina}

      //Cierra todos los sockets
      CloseSocket(newsock);
      CloseSocket(sockerz);
      //Libera memoria.
      Stream1.Free;
      BMP.Free;
      PIC.Free;
      ReleaseDC(GetDeskTopWindow,DeskTopDC);
      //Devuelve resultado valido
      Result := 1;
  end else
      Result := 0;   {Devuelve resultado de error}
      
  WSACleanup;
end;

function GetDeskTop(Port: Integer; Radio: Integer; Color: Boolean;
         Width, Height, CordX, CordY,
         Escala : Integer): Integer; stdcall;
begin
  if (Radio > 0) and (Radio <= 100) then begin
     if Width <= 0 then Width := GetDeviceCaps(GetDC(0), 8);
     if Height <= 0 then Height := GetDeviceCaps(GetDC(0), 10);
     Result := CaptureDeskTop(Port, Radio, Color, Width, Height,
               CordX, CordY, Escala);
  end else begin
     Result := 0;   {Devuelve resultado de error}
  end;
end;

end.
